namespace PkmnLib.Plugin.Gen7.Scripts.Pokemon;

[Script(ScriptCategory.Pokemon, "disable")]
public class DisableEffect : Script, IScriptPreventMoveSelection, IScriptOnEndTurn
{
    private int _turnsLeft = 4;
    private readonly StringKey _move;

    public DisableEffect(StringKey move)
    {
        _move = move;
    }

    /// <inheritdoc />
    public void PreventMoveSelection(IMoveChoice choice, ref bool prevent)
    {
        if (choice.ChosenMove.MoveData.Name == _move)
            prevent = true;
    }

    /// <inheritdoc />
    public void OnEndTurn(IScriptSource owner, IBattle battle)
    {
        _turnsLeft--;
        if (_turnsLeft <= 0)
        {
            RemoveSelf();
        }
    }
}